#!/usr/bin/perl

################################################################################
#     Beomdori's GuestBook v2.2
#
#     Programmer : BeomGyu, Lee
#     E-Mail          : cadeau@orgio.net
#     Homepage   : http://beomdori.x-y.net
#
################################################################################

#################################[ȯ漳]#######################################
$gBaseDIR = "./db";                # DB 丮
$gCGI_URL = "./bdr_guest.cgi";     #  CGI URL
$gCGI_Mail = "./bdr_mail.cgi";     #  CGI URL
$gIconURL = "./img";               # ̹ 丮 URL
$gCreateDB = "Y";                  # db 鶧 Y,  ̻ ȸ鶧 N 
################################################################################

$gVer = "v2.2";                    # ǥ( .)
$gLockFlag = "N";
$gLockStat = "N";

umask(000);
&parseArgument;
sub parseArgument {
    local($buffer,$data,$name,$value);
    local(@datum);

    if($ENV{'REQUEST_METHOD'} eq "GET") {
        $buffer = $ENV{'QUERY_STRING'};
    }
    else {
        read(STDIN,$buffer,$ENV{'CONTENT_LENGTH'});
    }

    @datum = split(/&/,$buffer);
    foreach $data (@datum) {
        ($name,$value) = split(/=/,$data);
        $value =~ tr/+/ /;
        $value =~ s/%([a-fA-F0-9]{2})/pack("C",hex($1))/eg;

        $FORM{$name} = $value;
    }
    
    if($FORM{'db'}) {
        $gBaseDIR = "$gBaseDIR/$FORM{'db'}";
        $gNumFile = "$FORM{'db'}_num.cgi";
        $gCfgFile = "$FORM{'db'}_cfg.cgi";
        $gPwdFile = "$FORM{'db'}_pwd.cgi";
        $gDatFile = "$FORM{'db'}_dat.cgi";
    }
    else {
        &HTMLHeader;
        print "<br><font color=$gTextColor><b>ũϴ </b></font>\n";
        print "<br><br><hr noshade width=50%>\n";
        print "<font color=black>$gCGI_URL<font color=red>?db= DB</font></font><br>\n";
        print "<hr noshade width=50%><p>\n";
        &HTMLFooter;
    }
    
    if(open(HANDLE,"<$gBaseDIR/$gNumFile")) {
        close(HANDLE);
        &selectAction;
    }
    else {
        if($gCreateDB eq "Y") {
            &selectAction;
        }
        else {
            &HTMLHeader;
            print "<br><br><hr noshade width=50%>\n";
            print "<font color=red> DB Ǿֽϴ.</font><br>\n";
            print "<hr noshade width=50%><p>\n";
            &HTMLFooter;
        }
    }
}

sub selectAction {
    &getNumber;
    &getEnvVar;

    unless($FORM{'action'}) {
        $FORM{'action'} = "r";
    }

    if($FORM{'action'} eq "r") {	
	&readData;
    } 
    elsif($FORM{'action'} eq "show_user_input_form") {
        &showUserInputForm;
    }
    elsif($FORM{'action'} eq "write") {
	&writeData;
    } 
    elsif($FORM{'action'} eq "delete") {
        &checkUserPassword;
	&deleteData;
    } 
    elsif($FORM{'action'} eq "show_update_form") {
        &checkUserPassword;
	&showUpdateForm;
    } 
    elsif($FORM{'action'} eq "show_reply_form") {
       &checkAdminPassword;
	&showReplyForm;
    }    
    elsif($FORM{'action'} eq "update") {
	&updateData;
    } 
    elsif($FORM{'action'} eq "users_login") {
        &showUsersLogin;
    }
    elsif($FORM{'action'} eq "admin_login") {
        &showAdminLogin;
    }
    elsif($FORM{'action'} eq "show_config_form") {
       &checkAdminPassword;
       &showConfigForm;
	}
    elsif($FORM{'action'} eq "config") {
        &updateEnvVar;
    }
    else {
        exit;
    }
}

##########################################################################
#  ȭ  ų DB 丮 ʱȭ
##########################################################################
sub getNumber {
    if(open(HANDLE,"<$gBaseDIR/$gNumFile")) {
        $gNoOfData = <HANDLE>;
        close(HANDLE);
        chop($gNoOfData);

        open(HANDLE,"<$gBaseDIR/$gDatFile");
            @datum = <HANDLE>;
        close(HANDLE);
        if($gNoOfData != $#datum) {
            $gNoOfData = $#datum;
            &putNumber;
        }
    }
    else {
        mkdir("$gBaseDIR",0777);  
        mkdir("$gBaseDIR/data",0777);

        open(HANDLE,">$gBaseDIR/$gDatFile");
            print HANDLE "<!--EOF-->\n";
        close(HANDLE);

        $gNoOfData = "0";
        &putNumber;
    } 
}

##########################################################################
# ȣ 
##########################################################################
sub putNumber {
    open(HANDLE,">$gBaseDIR/$gNumFile");
        print HANDLE "$gNoOfData\n";
    close(HANDLE);
}

##########################################################################
# bdr_guest ȯ漳 оδ.
##########################################################################
sub getEnvVar {
    local($env_list);
    local(@datum);

    if(open(HANDLE,"<$gBaseDIR/$gCfgFile")) {
        $env_list = <HANDLE>;
        close(HANDLE);
        @datum = split(/\|/,$env_list);

        $gBackColor = $datum[1];
        $gBackImgURL = $datum[2];
        
        $gDesignType = $datum[12];   # Ÿ
        
        $gRecPerPage = $datum[6];
        $gListNumber = $datum[7];

        $gTableWidth = $datum[5];
        $gTableBgcolor = $datum[21];
        $gTableText = $datum[15];
        $gActiveTableColor = $datum[14];
        $gTextColor = $datum[17];
        $gTitleUse = $datum[11];        
                        
        $gTempNum1 = $datum[20];   # 0 or 1              
      
        $gTempURL1 = $datum[26];        
        $gTempURL2 = $datum[4];  
        $gTempURL3 = $datum[3];        
        $gTempURL4 = $datum[29];
        $gTempURL5 = $datum[30];
        $gTempURL6 = $datum[31];
        $gTempURL7 = $datum[32];
        $gTempURL8 = $datum[33];              
        $gTempURL9 = $datum[28];        
        $gTempColor1 = $datum[8];
        $gTempColor2 = $datum[9];
        $gTempColor3 = $datum[18];        
        $gTempColor4 = $datum[16];
        $gTempColor5 = $datum[22];
        $gTempColor6 = $datum[23];
        $gTempColor7 = $datum[10];                
        $gTempColor8 = $datum[27];                        
        $gTempColor9 = $datum[13];        
        $gTempYesOrNo1 = $datum[19];        
        $gTempYesOrNo2 = $datum[24];
        $gTempYesOrNo3 = $datum[25];
        $gTempYesOrNo4 = $datum[36];        
        $gTempYesOrNo5 = $datum[35];                
        $gTempYesOrNo6 = $datum[34];
        chop($gHomeImageURL);
    }
    else {
        # ʱ ȯ 

        $gBackColor = "#ffffff";
        $gBackImgURL = "./img/sy1_bg.gif";

        $gDesignType = "style1";           # Ÿ : style1, style2, style3
                
        $gTableWidth = "500";
        $gTableBgcolor = "#ffffff";
        $gTableText = "#000000";
        $gActiveTableColor = "#f5f5f5";
        $gTextColor = "#000000";
        $gTitleUse = "YES";           
        
        $gRecPerPage = "10";
        $gListNumber = "5";


        $gTempNum1 = "1";
        $gTempColor1 = "#000000";
        $gTempColor2 = "#000000";        
        $gTempColor3 = "#000000";        
        $gTempColor4 = "#000000";        
        $gTempColor5 = "#000000";
        $gTempColor6 = "#000000";
        $gTempColor7 = "#000000";                
        $gTempColor8 = "#494949";                        
        $gTempColor9 = "#ffffff";                
        $gTempYesOrNo1 = "YES";
        $gTempYesOrNo2 = "YES";
        $gTempYesOrNo3 = "YES";
        $gTempYesOrNo4 = "YES";
        $gTempYesOrNo5 = "YES";        
        $gTempYesOrNo6 = "NO";
        $gTempURL1 = "";
        $gTempURL2 = "";
        $gTempURL3 = "";        
        $gTempURL4 = "";
        $gTempURL5 = "";
        $gTempURL6 = "";
        $gTempURL7 = "";
        $gTempURL8 = "";        
        $gTempURL9 = "";        
        &putEnvVar;
    }
}

##########################################################################
# bdr_guest ȯ漳 ȭϿ Ѵ.
########################################################################## 
sub putEnvVar {
    open(HANDLE,">$gBaseDIR/$gCfgFile");
        print HANDLE "|$gBackColor|$gBackImgURL|$gTempURL3|$gTempURL2|$gTableWidth|$gRecPerPage|$gListNumber|$gTempColor1|$gTempColor2|$gTempColor7|$gTitleUse|$gDesignType|$gTempColor9|$gActiveTableColor|$gTableText|$gTempColor4|$gTextColor|$gTempColor3|$gTempYesOrNo1|$gTempNum1|$gTableBgcolor|$gTempcolor1|$gTempcolor2|$gTempYesOrNo2|$gTempYesOrNo3|$gTempURL1|$gTempColor8|$gTempURL9|$gTempURL4|$gTempURL5|$gTempURL6|$gTempURL7|$gTempURL8|$gTempYesOrNo6|$gTempYesOrNo5|$gTempYesOrNo4|\n";
    close(HANDLE);
}

##########################################################################
# Ÿ оδ.
##########################################################################
sub readData {
    if($FORM{'p'}) {
        $gCurPage = $FORM{'p'};
    }
    else {
        $gCurPage = "1";
    }

    $gTotPage = int(($gNoOfData-1)/$gRecPerPage)+1;

    &HTMLHeader;

    &MenuButton;
    
    &readIndexFile;

    &FastGo;
        	
    &HTMLFooter;
}

##########################################################################
# ޴
##########################################################################
sub MenuButton {
    print "<font style=\"cursor:n-resize\">\n";
    print "<table width=$gTableWidth border=0 cellspacing=1 cellpadding=2 height=60 align=top>\n";
    print "<tr>\n";
    print "<td align=left align=top width=20%>\n";
    print "<a href=$gCGI_URL?db=$FORM{'db'}&action=admin_login&p=$gCurPage&c=show_config_form><img src=$gIconURL/admin.gif border=0 alt=\"Administrator\"></a> \n";    
    print "<a href=$gCGI_URL?db=$FORM{'db'}&action=show_user_input_form><img src=$gIconURL/write.gif border=0 alt=\"Write\"></a>\n";
    print "</td>\n";
    print "<td width=60% align=center align=top>  <font color=red><b>$gNoOfData</b></font> ־.</td>\n";
    print "<td align=right align=top width=20%>\n";
    
    $term = 1;
    $f = 1;
    $l = $term;
    while ($f <= $gTotPage) {
      if (($f <= $gCurPage) && ($gCurPage <= $l)) {
         $prevp = $f - 1;
        if ($prevp > 0) {
          print "<a href=$gCGI_URL?db=$FORM{'db'}&action=r&p=$prevp><img src=$gIconURL/previous.gif border=0 alt=\"Previous Page\"></a> ";
        }
        else {
          print "<img src=$gIconURL/previous_n.gif border=0 alt=\"First Page\"> ";
        }
       $nextp = $l + 1;
       if ($nextp <= $gTotPage) {
         print "<a href=$gCGI_URL?db=$FORM{'db'}&action=r&p=$nextp><img src=$gIconURL/next.gif border=0 alt=\"Next Page\"></a>";
       }
       else {
         print "<img src=$gIconURL/next_n.gif border=0 alt=\"Last Page\">";
       }
     }
     $f = $f + $term;
     $l = $l + $term;
   }

    print "</td></tr>\n";
    print "</table></font>\n";
}

##########################################################################
# ȭ ŸϿ  
##########################################################################
sub readIndexFile {
    local($i,$j,$rec_color,$txt_color,$actual_number,$short_subject,$short_date,$old_date,$new_date);
    local(@datum,@value);

    open(HANDLE,"$gBaseDIR/$gDatFile");
        @datum = <HANDLE>;
    close(HANDLE);
   
    print "<table border=0 width=$gTableWidth cellspacing=0 cellpadding=0 valign=top align=center>\n";
    print "<tr><td>\n";
      
    for($i=($gCurPage-1)*$gRecPerPage+1;$i<=($gCurPage-1)*$gRecPerPage+$gRecPerPage;$i++) {
        @value = split(/\|/,$datum[$i]);    
        $actual_number = ($gNoOfData+1)-$i;

        if($actual_number > 0) {
           $date_length = length($date);
           $short_date = substr($value[5],0,20);

          $value[6] =~ s/\|/&#124;/g;            
          $value[6] =~ s/(http:\/\/)([\&\w\+\-\/\=\?\.\~]+)/$url <img src=$gIconURL\/home.gif> <a href=\"$1$2\" target=\"_blank\">$1$2<\/a>/g;
          $value[6] =~ s/([\w\-]+\@[\w\-+\.]+[\w\-]+)/$mail <img src=$gIconURL\/mail.gif> <a href=\"javascript:smail('$gCGI_Mail?tomail=$1')\">$1<\/a>/g;
          
          # Ÿ1         
          if($gDesignType eq "style1") {
             print "<table border=1 cellpadding=0 cellspacing=0 width=100% align=center  bordercolorlight=#3E56a3 bordercolordark=#ffffff>\n<tr onMouseOver=this.style.backgroundColor=\"#f5f5f5\" onMouseOut=this.style.backgroundColor=\"\"><td>\n";
             print "<table border=0 cellpadding=0 cellspacing=0 width=100%>\n<tr><td colspan=2>\n";
             print "<table border=0 cellpadding=5 cellspacing=0 width=100%>\n";
               if($value[8] eq "http://" || $value[8] eq "") {
	   if($value[4] eq "") {
	      print "<tr><td><img src=$gIconURL/sy1_home.gif border=0><font face=޸տü,ü color=#aa84FF>$value[2]</font>&nbsp;&nbsp;(<font color=#ff3344>$value[5]</font>)</td>\n";	
	   }
	   else {
	      print "<tr><td><img src=$gIconURL/sy1_home.gif border=0><a href=\"javascript:smail('$gCGI_Mail?tomail=$value[4]')\"><font face=޸տü,ü color=#aa84FF>$value[2]</font></a>&nbsp;&nbsp;(<font color=#ff3344>$value[5]</font>)</td>\n";
	   }
	}
	else {
	   if($value[4] eq "") {
	      print "<tr><td><a href=$value[8] target=\"_blank\" title=\"$value[8]\"><img src=$gIconURL/sy1_home.gif border=0></a><font face=޸տü,ü color=#aa84FF>$value[2]</font>&nbsp;&nbsp;(<font color=#ff3344>$value[5]</font>)</td>\n";
	   }
	   else {
                      print "<tr><td><a href=$value[8] target=\"_blank\" title=\"$value[8]\"><img src=$gIconURL/sy1_home.gif border=0></a><a href=\"javascript:smail('$gCGI_Mail?tomail=$value[4]')\"><font face=޸տü,ü color=#aa84FF>$value[2]</font></a>&nbsp;&nbsp;(<font color=#ff3344>$value[5]</font>)</td>\n";
	   }	
                }
                print "<td align=right><a href=$gCGI_URL?db=$FORM{'db'}&action=users_login&p=$FORM{'p'}&c=show_update_form&l=$value[1]><img src=$gIconURL/sy1_mod.gif border=0 alt=\"Modify\"></a><a href=$gCGI_URL?db=$FORM{'db'}&action=users_login&p=$FORM{'p'}&c=delete&l=$value[1]><img src=$gIconURL/sy1_del.gif border=0 alt=\"Delete\"></a><a href=$gCGI_URL?db=$FORM{'db'}&action=users_login&p=$FORM{'p'}&c=show_reply_form&l=$value[1]><img src=$gIconURL/sy1_reply.gif border=0 alt=\"Reply\"></a></td></tr>\n";
                print "<tr><td width=$table_size colspan=3><ul>";
	print "<font face=޸տü color=black>$value[6]\n";
	print "</font></ul>\n";
                if ($value[9] ne "") {
	    print "<p><ul><img src=$gIconURL/sy1_speak.gif border=0>&nbsp;<font color=#4455cc face=޸տü,ü>$value[2]Կ...</font><br>&nbsp;&nbsp;<font color=#555577 face=޸տü,ü>$value[9]</font></ul><br>\n";
	}	
	print "</td></tr></table>\n</td></tr></table>\n";
	print "</td></tr></table>\n";
	print "<br><br><center><table><tr><td background=$gIconURL/sy1_line.gif border=0 width=$gTableWidth height=3></td></tr><table></center><br><br>\n";
          }
          # Ÿ1 

          # Ÿ2         
          elsif($gDesignType eq "style2"){
	print "<table border=0 cellpadding=0 cellspacing=0 width=100% align=center>\n";
	print "<tr><td background=\"$gIconURL/sy2_tb1.gif\" height=6></td><td height=6 style=\"background-image:url($gIconURL/sy2_tb2.gif); background-repeat:repeat-x; background-position:left top\"></td><td background=\"$gIconURL/sy2_tb3.gif\" height=6></td></tr>\n";
	print "<tr><td width=6 style=\"background-image:url('$gIconURL/sy2_tb2.gif'); background-repeat:repeat-y; background-position:left top\"></td>\n";
	print "<td><table border=0 cellpadding=9 cellspacing=7 width=100%>\n";
	if($value[8] eq "http://" || $value[8] eq "") {
	   if($value[4] eq "") {
	       print "<tr><td width=150 align=left>&nbsp;$actual_number.&nbsp;<b>$value[2]</b>&nbsp;&nbsp;&nbsp;</td><td align=right>&nbsp;<font color=aaaaaa size=1>$value[5]</font></td></tr>\n";
	   }	
	   else {
	       print "<tr><td width=150 align=left>&nbsp;$actual_number.&nbsp;<b>$value[2]</b>&nbsp;&nbsp;<a href=\"javascript:smail('$gCGI_Mail?tomail=$value[4]')\"><img src=$gIconURL/sy2_email.gif border=0></a>&nbsp;</td><td align=right>&nbsp;<font color=aaaaaa size=1>$value[5]</font></td></tr>\n";
	   }		
	}
	else {
	   if($value[4] eq "") {
	       print "<tr><td width=150 align=left>&nbsp;$actual_number.&nbsp;<b>$value[2]</b>&nbsp;&nbsp;<a href=\"$value[8]\" target=\"_blank\" title=\"$value[8]\"><img src=$gIconURL/sy2_home.gif border=0></a></td><td align=right>&nbsp;<font color=aaaaaa size=1>$value[5]</font></td></tr>\n";
	   }	
	   else {
	       print "<tr><td width=150 align=left>&nbsp;$actual_number.&nbsp;<b>$value[2]</b>&nbsp;&nbsp;<a href=\"javascript:smail('$gCGI_Mail?tomail=$value[4]')\"><img src=$gIconURL/sy2_email.gif border=0></a>&nbsp;<a href=\"$value[8]\" target=\"_blank\" title=\"$value[8]\"><img src=$gIconURL/sy2_home.gif border=0></a></td><td align=right>&nbsp;<font color=999999 size=1>$value[5]</font></td></tr>\n";
	   }		
	}			
	print "<tr><td width=100% colspan=2 align=left valign=bottom>";
	print "<table border=0><tr><td valign=top><img src=$gIconURL/sy2_content.gif border=0></td><td>";
	print "<font color=#333333>$value[6]</font></td></tr></table>\n";
	if ($value[9] ne "") {
	    print "<p><ul><img src=$gIconURL/sy2_speak.gif border=0>&nbsp;<font color=#555555 face=\"Tahoma,ü\"><b>$value[2]</b>Կ...</font><br><font color=#222222>$value[9]</font></ul><br>\n";
	}	
	print "<br><center><a href=$gCGI_URL?db=$FORM{'db'}&action=users_login&p=$FORM{'p'}&c=show_update_form&l=$value[1]><img src=$gIconURL/sy2_mod.gif border=0 alt=\"Modify\"></a> <a href=$gCGI_URL?db=$FORM{'db'}&action=users_login&p=$FORM{'p'}&c=delete&l=$value[1]><img src=$gIconURL/sy2_del.gif border=0 alt=\"Delete\"></a> <a href=$gCGI_URL?db=$FORM{'db'}&action=users_login&p=$FORM{'p'}&c=show_reply_form&l=$value[1]><img src=$gIconURL/sy2_reply.gif border=0 alt=\"Reply\"></a></center></td></tr></table>\n";
	print "</td><td width=6 style=\"background-image:url('$gIconURL/sy2_tb4.gif'); background-repeat:repeat-y; background-position:right top\"></td></tr>\n";
	print "<tr><td background=\"$gIconURL/sy2_tb5.gif\" height=6></td><td height=6 style=\"background-image:url('$gIconURL/sy2_tb6.gif'); background-repeat:repeat-x; background-position:left bottom\"></td><td background=\"$gIconURL/sy2_tb7.gif\" height=6></td>\n";
	print "</tr></table>\n";
	print "<br><br>\n\n";
          }
          # Ÿ2 
          
          # Ÿ3 
          elsif($gDesignType eq "style3"){
	print "<table border=0 cellpadding=0 cellspacing=0 width=100%><tr><td background=$gIconURL/sy3_tb1.gif width=22 height=22></td><td background=$gIconURL/sy3_tb5.gif ></td><td background=$gIconURL/sy3_tb2.gif width=22 height=22></td></tr><tr><td background=$gIconURL/sy3_tb7.gif></td><td>\n";
	if($value[4] eq "") {
                   print "<table border=0 cellpadding=0 cellspacing=0 width=100%><tr><td><p align=left valign=bottom>&nbsp;<img src=$gIconURL/sy3_an1.gif border=0>&nbsp;<font face=ü color=#ff3322>$value[2]</font><font color=#666666> <font color=#7fbb77>$value[5]</font>  ...</font></td><td width=70 align=right valign=bottom><a href=$gCGI_URL?db=$FORM{'db'}&action=users_login&p=$FORM{'p'}&c=show_update_form&l=$value[1]><img src=$gIconURL/sy3_mod.gif border=0 alt=\"Modify\"></a><a href=$gCGI_URL?db=$FORM{'db'}&action=users_login&p=$FORM{'p'}&c=delete&l=$value[1]><img src=$gIconURL/sy3_del.gif border=0 alt=\"Delete\"></a><a href=$gCGI_URL?db=$FORM{'db'}&action=users_login&p=$FORM{'p'}&c=show_reply_form&l=$value[1]><img src=$gIconURL/sy3_reply.gif border=0 alt=\"Reply\"></a></td></tr>\n"
	}
	else {
                   print "<table border=0 cellpadding=0 cellspacing=0 width=100%><tr><td><p align=left valign=bottom>&nbsp;<img src=$gIconURL/sy3_an1.gif border=0>&nbsp;<a href=\"javascript:smail('$gCGI_Mail?tomail=$value[4]')\"><font face=ü color=#ff3322>$value[2]</a></font><font color=#666666> <font color=#7fbb77>$value[5]</font>  ...</font></td><td width=70 align=right valign=bottom><a href=$gCGI_URL?db=$FORM{'db'}&action=users_login&p=$FORM{'p'}&c=show_update_form&l=$value[1]><img src=$gIconURL/sy3_mod.gif border=0 alt=\"Modify\"></a><a href=$gCGI_URL?db=$FORM{'db'}&action=users_login&p=$FORM{'p'}&c=delete&l=$value[1]><img src=$gIconURL/sy3_del.gif border=0 alt=\"Delete\"></a><a href=$gCGI_URL?db=$FORM{'db'}&action=users_login&p=$FORM{'p'}&c=show_reply_form&l=$value[1]><img src=$gIconURL/sy3_reply.gif border=0 alt=\"Reply\"></a></td></tr>\n";	
	}
			
	if($value[8] eq "http://" || $value[8] eq "") {
                   print "<tr><td colspan=2><table border=0 cellpadding=5 cellspacing=0 width=100%><tr><td align=left>&nbsp;</td>\n";
	}
	else {
	   print "<tr><td colspan=2><table border=0 cellpadding=5 cellspacing=0 width=100%><tr><td align=left><img src=$gIconURL/sy3_home.gif><a href=$value[8] target=\"_blank\"> <font face=ü color=#8866ff>$value[8]</font></a></td>\n";
               }			
	print "<td>&nbsp;</td></tr>\n";
	print "<tr><td colspan=2>";
	print "<font face=\"޸տü,ü,ü\" color=#444444>$value[6]</font>";
	if ($value[9] ne "") {
	    print "<p><ul><img src=$gIconURL/sy3_speak.gif border=0>&nbsp;<font color=#ffaa66 face=\"޸տü,ü,ü\">$value[2]Կ...</font><br>&nbsp;&nbsp;<font color=#44547f face=\"޸տü,ü,ü\">$value[9]</font></ul><br>\n";
	}	
	print "</td></tr></table></td></tr></table>\n";
	print "</td><td background=$gIconURL/sy3_tb8.gif></td></tr><tr><td background=$gIconURL/sy3_tb3.gif width=22 height=22></td><td background=$gIconURL/sy3_tb6.gif></td><td background=$gIconURL/sy3_tb4.gif width=22 height=22></td></tr></table>\n";
	print "</div><br><center><img src=$gIconURL/sy3_an2.gif><p></center>\n";          	
          }
          # Ÿ3 
       }
   }
   print "</td></tr></table>\n";
   
   unless($gNoOfData) {
        print "&nbsp;<table width=$gTableWidth border=0 cellspacing=1 cellpadding=6 align=center>\n";
        print "<tr align=center><td><font color=\"red\"><b> ϵ  ϴ.</font></b></td></tr></table>\n";
    }
}

##########################################################################
#  
##########################################################################
sub FastGo {
print "<table border=0 cellpadding=9 cellspacing=1 align=center valign=top><tr><td align=center>\n";
$term = $gListNumber;$f = 1;$l = $term;while ($f <= $gTotPage) {
if (($f <= $gCurPage) && ($gCurPage <= $l))
{$prevp = $f - 1;

if ($prevp > 0) {
print "<a href=$gCGI_URL?db=$FORM{'db'}&action=r&p=$prevp><img src=$gIconURL/arrow_left.gif border=0 alt=\" \"></a>..";
}
else {
print "<img src=$gIconURL/arrow_left.gif border=0>..";
}
if ($l <= $gTotPage) {
	for ($page = $f; $page <= $l; $page++) {
	if ($page == $gCurPage) {
print "<font color=$gTableText>[<font color=blue><b>$page</b></font>]</font>";
	}
else {
print "<a href=$gCGI_URL?db=$FORM{'db'}&action=r&p=$page>[$page]</a>";
}}}
else {
for ($page = $f; $page <= $gTotPage; $page++) {
	if ($page == $gCurPage) {
print "<font color=$gTableText>[<font color=blue><b>$page</b></font>]</font>";
}
else {
print "<font color=$gTextColor><a href=$gCGI_URL?db=$FORM{'db'}&action=r&p=$page>[$page]</font></a>";
}}}
$nextp = $l + 1;
  	if ($nextp <= $gTotPage) {
print "..<a href=$gCGI_URL?db=$FORM{'db'}&action=r&p=$nextp><img src=$gIconURL/arrow_right.gif border=0 alt=\" \"></a>";
}
else {print "..<img src=$gIconURL/arrow_right.gif border=0>";
}    }$f = $f + $term;
$l = $l + $term;}
print "</td></tr></table>\n";
}


##########################################################################
# htmlӸ
##########################################################################
sub HTMLHeader {
    print "Content-type: text/html\n\n";
    print "<!------------------------------------------------------------------------>\n";
    print "<!--  Program Name  : Beomdori's GuestBook $gVer                         -->\n";
    print "<!--  Programer     : BeomGyu Lee                                       -->\n";
    print "<!--  E-Mail        : cadeau\@orgio.net                                 -->\n";
    print "<!--  Homepage      : http://beomdori.x-y.net                           -->\n";
    print "<!------------------------------------------------------------------------>\n\n";        
    print "<html>\n";
    print "<title>Beomdori's GuestBook $gVer</title>\n";    
    print "<meta http-equiv=\"desription\" name=\"description\" content=\"text/html; charset=KS_C_5601-1987; charset=euc-kr\">\n";        
    print "<style type='text/css'>\n";
    print "<!--\n";	
	if($gDesignType eq "style1") {
		$title = "sy1_title.gif";
	}
	elsif($gDesignType eq "style2") {
		$title = "sy2_title.gif";
	}
	else{
		$title = "sy3_title.gif";
	}
    
    print " BODY {background:url(\"$gBackImgURL\") $bgcolor fixed no-repeat 98% 98%}\n";
    print "-->\n";
    print "</style>\n" ;    
    print "<link rel=\"stylesheet\" type=\"text/css\" href=\"./bdr_guest.css\">\n";
    print "<script language=\"JavaScript\">\n";
    print "function nextWin()\n";
    print "{location = \"$gCGI_URL?db=$FORM{'db'}&action=r&p=$FORM{'p'}\"}\n";
    print "</script>\n";
    print "<script language=javascript>\n";
    print "function clearField(field){ if (field.value == field.defaultValue) {  field.value = ''; } }\n";
    print "function checkField(field){ if (field.value == '') { field.value = field.defaultValue; } }\n";
    print "</script>\n\n";
    print "<SCRIPT language=JavaScript>\n";
    print "function smail(URL) {\n";
    print "window.open(URL,'smail','left=200, top=200, toolbar=no, location=no, directories=no, status=no, menubar=no, scrollbars=no, resizable=no, width=309, height=338');\n";
    print "}</SCRIPT>\n";
    print "</head>\n";    

    if($gDelayTime == 0) {
        $gBackColor = "#ffffff" unless($gBackColor);
        print "<body bgcolor=$gBackColor topmargin=0 oncontextmenu='return true'>\n";
    }
    else {
        print "<meta http-equiv=refresh content=1;url=$gCGI_URL?db=$FORM{'db'}&action=r&p=$FORM{'p'}>\n";
        $gBackColor = "#ffffff" unless($gBackColor);
        print "<body bgcolor=$gBackColor topmargin=0 oncontextmenu='return ture'><br>\n";
    }

    print "<center><br>\n";    
    
    if($gTitleUse eq "YES" || $gTitleUse eq "") {
       print"<br><img src=$gIconURL/$title border=0><p>\n";
    }
}

##########################################################################
# html
##########################################################################
sub HTMLFooter {
    &copyright;
    print "</center>\n";
    print "</body>\n";
    print "</html>\n";
    exit;
}

##########################################################################
# ۱
##########################################################################
sub copyright {
       print "\n<center><br><br><a href=\"http://www.wonie.co.kr\" target=\"_blank\"><font color=\"#444444\" size=1 face=Tahoma>Created by <font color=\"#444444\" size=1 face=Tahoma>Wonie</font></a> / <a href=\"http://beomdori.x-y.net\" target=\"_blank\"><font color=\"#444444\" size=1 face=Tahoma>Modified by <font color=\"#444444\" size=1 face=Tahoma>Beomdori</font></a></font><br><br><br>\n";
}

##########################################################################
#  ۾ 
##########################################################################
sub showUserInputForm {
    local($data,$subject,$content,$subject2,$name,$value);
    local(@value,@cookies);
    
    # Űб 
    if($ENV{'HTTP_COOKIE'}) {
        @cookies = split(/; /,$ENV{'HTTP_COOKIE'});
        foreach(@cookies) {
            ($name,$value) = split(/=/,$_);
            $COOKIE{$name} = $value;
        }
    }
 
    &HTMLHeader;
    print "<form method=post name=inputForm action=$gCGI_URL>\n";    
    print "<br><table border=0 cellspacing=0 cellpadding=0>\n";
    print "<tr><td>\n";

    print "<table border=0 cellspacing=1 cellpadding=2>\n";    
    print "<input type=hidden name=db value=$FORM{'db'}>\n";
    print "<input type=hidden name=action value=write>\n";
    print "<input type=hidden name=p value=1>\n";
    
    print "<tr><td align=right><span class=cls><b>Password</b></span></td>\n";
    print "<td><input type=password name=passwd size=14 maxlength=16 class=text></td></tr>\n";
    print "<tr><td align=right><span class=cls><b>Name</b></span></td><td>\n";
    print "<input name=subject value='' type=text size=14 value='' class=text>\n";
    print "<input type=hidden name=html value=enable checked></tr>\n";    
    print "<tr><td align=right><span class=cls><b>E-Mail</b></span></td><td>\n";
    print "<input name=email value='' type=text size=34 class=text></td></tr>\n";                    
    print "<tr><td align=right><span class=cls><b>Homepage</b></span></td><td>\n";
    print "<input name=homepage type=text value='http://' size=34 class=text>\n";
    print "<input type=hidden name=phone value=\"$value[3]\">\n";                             # Ӽ : ó
    print "<input type=hidden name=reply value=\"$value[9]\">\n";                              # Ӽ : ۴ޱ    
    print "<input type=hidden name=ip value=\"$value[7]\">\n";                              # Ӽ : ip    
    print "<input type=hidden name=date value=\"$value[5]\">\n";                              # Ӽ : ¥            
    print "</td></tr>\n";         
    print "<tr><td align=right valign=top><span class=cls><b>Comment</b></span></td><td><textarea name=subject2 rows=8 cols=45 class=comment></textarea></td>\n";
    print "</tr>\n";
    print "<tr><td align=center colspan=2><input type=submit value=\" Ȯ  \" class=submit onmouseover=\"this.style.backgroundColor= 'silver'\"onmouseout=\"this.style.backgroundColor=''\"> <input type=reset value=\" Է \" class=submit onmouseover=\"this.style.backgroundColor= 'silver'\"onmouseout=\"this.style.backgroundColor=''\"></td>\n";
    print "</tr></table>\n";
    print "</td></tr></table>\n";
    print "</form>\n";
    print "<script language=\"javascript\">document.inputForm.passwd.focus();</script>\n";
    
    &HTMLFooter;
}

##########################################################################
# ȭϿ Է  Ѵ.
##########################################################################
sub writeData {
    &getNumber;
    &getVariable;
   
    &makeCryptPassword if($passwd);
    &makeNewFile;
    &appendIndexFile;
    &sendMail if($gAdminEmail);
    $gNoOfData++;
    &putNumber;

    print "Content-type: text/html\n\n";
    print "<!---------------------------------------------------------------------------------->\n";
    print "<!--  Program Name  : Beomdori's GuestBook $gVer                                   -->\n";
    print "<!--  Programer     : BeomGyu Lee                                                  -->\n";
    print "<!--  E-Mail        : cadeau\@orgio.net                                           -->\n";
    print "<!--  Homepage      : http://beomdori.x-y.net                                     -->\n";
    print "<!---------------------------------------------------------------------------------->\n\n";        
    print "<html>\n";
    print "<title>Beomdori's GuestBook $gVer</title>\n";    
    print "<meta http-equiv=\"desription\" name=\"description\" content=\"text/html; charset=KS_C_5601-1987; charset=euc-kr\">\n";        
    print "<link rel=\"stylesheet\" type=\"text/css\" href=\"./bdr_guest.css\">\n";
    print "<style>\n" ;
    print " BODY {background:url(\"$gBackImgURL\") $gBackColor fixed no-repeat 98% 98%}\n";
    print "</style>\n" ;    
    print "<script language=\"JavaScript\">\n";
    print "function nextWin()\n";
    print "{location = \"$gCGI_URL?db=$FORM{'db'}&action=r&p=$FORM{'p'}\"}\n";
    print "</script>\n";

    if($gDelayTime == 0) {
        $gBackColor = "#ffffff" unless($gBackColor);
        print "<body bgcolor=$gBackColor oncontextmenu='return false'>\n";
    }
    else {
        print "<meta http-equiv=refresh content=2;url=$gCGI_URL?db=$FORM{'db'}&action=r&p=$FORM{'p'}>\n";
        $gBackColor = "#ffffff" unless($gBackColor);
        print "<body bgcolor=$gBackColor oncontextmenu='return false'>\n";
    }
    
    if($gDesignType eq "1") {
       print "<div id=\"overDiv\" style=\"position:absolute; left:0px; top:0px; z-index:1; visibility:hidden; border-style:none;\"></div>\n";
       print "<script language=\"JavaScript\" src=\"./bdr_guest.js\"></script>\n";    
    }
    print "<meta http-equiv=refresh content=\"0;  url=$gCGI_URL?db=$FORM{'db'}&action=r&p=$FORM{'p'}\">\n";

    print "</body></html>\n";
}

##########################################################################
# Է  ´
##########################################################################
sub getVariable {
# ȣ	
    if($FORM{'passwd'}) {
        $passwd = "$FORM{'passwd'}";
    }

# ̸
    unless($FORM{'subject'} =~ /^\s*$/) {
        $subject = "$FORM{'subject'}";
        $subject =~ s/\r\n/<br>/g;
    }
    else {
        &error(no_subject);
    }

# ϰ 
    if($FORM{'subject2'}) {
       $subject2 = "$FORM{'subject2'}";
       $subject2 =~ s/\r\n/<br>/g;
    }
    else {
       &error(no_subject2);
    }

# ۴ޱ
    if($FORM{'reply'}) {
       $reply = "$FORM{'reply'}";
       $reply =~ s/\r\n/<br>/g;
    }
    
# ̸
    if($FORM{'email'}) {
        $email = "$FORM{'email'}";
        $email =~ s/\|/&#124;/g;
    }
    else {
        $email = "";
    }
    
# Ȩ
    if($FORM{'homepage'}) {
       if($FORM{'homepage'} eq 'http://') {
       	  $homepage = "";
       }
       else {
          $homepage = "$FORM{'homepage'}";
          $homepage =~ s/\|/&#124;/g;
        }
    }

# ó
    if($FORM{'phone'}) {
        $phone = "$FORM{'phone'}";
        $phone =~ s/\|/&#124;/g;
    }
    else {
        $phone = "";
    }

    if($FORM{'date'} eq "") {
        &getDate;            
    }
    else {
        $date = "$FORM{'date'}";
        $date =~ s/\|/&#124;/g;
    }
    
    if($FORM{'ip'} eq "") {
        $ip = $ENV{'REMOTE_ADDR'};
    }
    else {
        $ip = "$FORM{'ip'}";
        $ip =~ s/\|/&#124;/g;
    }        
}

##########################################################################
# ¥
##########################################################################
sub getDate {     
	($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst)=localtime(time);
	$month=($mon+1);
	if($year ne "99"){
		if($year > 100){
			$year=($year-100)+2000;
		}
		elsif($year < 10){
			$year=2000+$year;	
		}
		else{
		$year="2000";
		}
        }
        else {
	   $year="1999";
        }
	if($month < 10) { $month="0$month";}
	if($mday < 10) { $mday="0$mday";}
	if($min < 10) { $min="0$min";}
	if($sec < 10) { $sec="0$sec";}
	
                $date = "$year/$month/$mday, $hour:$min:$sec"; 
                $d = "$year$month$mday";
}  

##########################################################################
# Ϻ
##########################################################################
sub sendMail {
    open(MAIL,"|$gEmailPgm -t $mail");
    print MAIL "To: $email\n";
    print MAIL "From: $gAdminEmail\n";
    print MAIL "Subject: $gEmailSubject\n";
    $gEmailContent =~ s/<p>/\n\n/g;
    $gEmailContent =~ s/<br>/\n/g;
    print MAIL "$gEmailContent";
    close(MAIL);
}

##########################################################################
# 
##########################################################################
sub error {
    local($error) = $_[0];
    
    &HTMLHeader;
    if($error eq "no_subject") {
        print "<br><br><hr noshade width=80%>\n";
        print "<font color=blue≯ ݵ ּ.</font><br>\n";
        print "<hr noshade width=80%><p>\n";
    }
    if($error eq "no_subject2") {
        print "<br><br><hr noshade width=80%>\n";
        print "<font color=blue> ݵ ּ.</font><br>\n";
        print "<hr noshade width=80%><p>\n";
    }

    print "<p><a href=$gCGI_URL?db=$FORM{'db'}&action=r&p=$FORM{'p'}><font color=$gTextColor>[ư]</font></a>\n";
    &HTMLFooter;
}

##########################################################################
#  α δ
##########################################################################
sub showUsersLogin {
    local($command);

    if($FORM{'c'} eq "delete") {
        $command = "delete";
    }
    elsif($FORM{'c'} eq "show_reply_form") {
        $command = "show_reply_form";
    }
    else {
        $command = "show_update_form";
    }
       
    &HTMLHeader;   
    if($FORM{'c'} eq "show_reply_form") {
    print "<form method=post name=reply action=$gCGI_URL>\n";
    print "<input type=hidden name=db value=$FORM{'db'}>\n";     
    print "<input type=hidden name=p value=$FORM{'p'}>\n";
    print "<input type=hidden name=action value=$command>\n";    
    print "<input type=hidden name=l value=$FORM{'l'}>\n";
    
    print "<input type=hidden name=ps value=old>\n";
            
    print "<br><b>Reply</b><br><br>\n";
    print "<font color=$gTextColor>йȣ </font>\n";
    print "<input type=password name=oldpasswd size=12 maxlength=16> \n";
    print "<input type=submit value=\" Ȯ  \">\n" if($command eq "show_reply_form");    	
    print "</form>\n";
    print "<script language=\"javascript\">document.reply.oldpasswd.focus();</script>\n";    
    }
    else {
    print "<form method=post name=userlogin action=$gCGI_URL>\n";
    print "<input type=hidden name=db value=$FORM{'db'}>\n"; 
    print "<input type=hidden name=p value=$FORM{'p'}>\n";
    print "<input type=hidden name=action value=$command>\n";
    print "<input type=hidden name=l value=$FORM{'l'}>\n";
    print "<br><b>Modify/Delete</b><br><br>\n";
    print "<font color=$gTextColor>йȣ </font>\n";
    print "<input type=password name=passwd size=12 maxlength=16> \n";
    print "<input type=submit value=\" Ȯ  \">\n" if($command eq "delete");
    print "<input type=submit value=\" Ȯ  \">\n" if($command eq "show_update_form");
    print "</form>\n";
    print "<script language=\"javascript\">document.userlogin.passwd.focus();</script>\n";
    }
    &HTMLFooter;       
}

##########################################################################
#  ȣ üũѴ
##########################################################################
sub checkUserPassword {
    local($data,$crypt_code,$save_password,$crypt_password);
    local(@passwd,@set,@datum,@value);
 
    open(HANDLE,"$gBaseDIR/data/$FORM{'l'}.cgi");
        $data = <HANDLE>;
    close(HANDLE);
    @passwd = split(/\|/,$data);

    open(HANDLE,"$gBaseDIR/$gPwdFile");
        $save_password = <HANDLE>;
    close(HANDLE);
    chop($save_password);

    @set = ('a'..'z','A'..'Z','0'..'9','.','/');
    $crypt_code = "$set[9]$set[3]";
    $crypt_password = crypt($FORM{'passwd'},$crypt_code);

    unless($crypt_password eq $passwd[0] || $crypt_password eq $save_password) {
        &HTMLHeader;
        print "<br><br><hr noshade width=80%>\n";
        print "<font color=$gTextColor> йȣ ġ ʽϴ.</font>\n";        
        print "<hr noshade width=80%>\n";
        print "</form><p><a href=$gCGI_URL?db=$FORM{'db'}&action=r&p=$FORM{'p'}><font color=$gTextColor>[ư]</font></a>\n";
        &HTMLFooter;
    } 
    
}

##########################################################################
# ϵ ȭ Ѵ
##########################################################################
sub deleteData {
    local(@datum,@value);
 
    open(HANDLE,"$gBaseDIR/$gDatFile");
        @datum = <HANDLE>;
    close(HANDLE);
    open(HANDLE,">$gBaseDIR/$gDatFile");
    foreach $data (@datum) {
        @value = split(/\|/, $data);
        if($FORM{'l'} != $value[1]) {
            print HANDLE "$data";             
        }
    }
    close(HANDLE);

    unlink("$gBaseDIR/data/$FORM{'l'}.cgi");

    &getNumber;
    $gNoOfData--;
    &putNumber;

    print "Content-type: text/html\n\n";
    print "<!---------------------------------------------------------------------------------->\n";
    print "<!--  Program Name  : Beomdori's GuestBook $gVer                                   -->\n";
    print "<!--  Programer     : BeomGyu Lee                                                  -->\n";
    print "<!--  E-Mail        : cadeau\@orgio.net                                           -->\n";
    print "<!--  Homepage      : http://beomdori.x-y.net                                     -->\n";
    print "<!---------------------------------------------------------------------------------->\n\n";        
    print "<html>\n";
    print "<title>Beomdori's GuestBook $gVer</title>\n";    
    print "<meta http-equiv=\"desription\" name=\"description\" content=\"text/html; charset=KS_C_5601-1987; charset=euc-kr\">\n";        
    print "<link rel=\"stylesheet\" type=\"text/css\" href=\"./bdr_guest.css\">\n";
    print "<style>\n" ;
    print " BODY {background:url(\"$gBackImgURL\") $gBackColor fixed no-repeat 98% 98%}\n";
    print "</style>\n" ;    
    print "<script language=\"JavaScript\">\n";
    print "function nextWin()\n";
    print "{location = \"$gCGI_URL?db=$FORM{'db'}&action=r&p=$FORM{'p'}\"}\n";
    print "</script>\n";

    if($gDelayTime == 0) {
       $gBackColor = "#ffffff" unless($gBackColor);
       print "<body bgcolor=$gBackColor oncontextmenu='return false'>\n";
    }
    else {
        print "<meta http-equiv=refresh content=2;url=$gCGI_URL?db=$FORM{'db'}&action=r&p=$FORM{'p'}>\n";
        $gBackColor = "#ffffff" unless($gBackColor);
        print "<body bgcolor=$gBackColor oncontextmenu='return false'>\n";
    }

    print "<meta http-equiv=refresh content=\"0;  url=$gCGI_URL?db=$FORM{'db'}&action=r&p=$FORM{'p'}\">\n";

    print "</body></html>\n";
}

##########################################################################
# ϵ ȭ  Ʈ 
##########################################################################
sub showUpdateForm {
    local($data,$name,$value);
    local(@cookies);
    
    # Ű б
    local(@value);
    if($ENV{'HTTP_COOKIE'}) {
        @cookies = split(/; /,$ENV{'HTTP_COOKIE'});
        foreach(@cookies) {
            ($name,$value) = split(/=/,$_);
            $COOKIE{$name} = $value;
        }
    }
 
    open(HANDLE,"$gBaseDIR/data/$FORM{'l'}.cgi");
        $data = <HANDLE>;
    close(HANDLE);
    @value = split(/\|/,$data);             

    &HTMLHeader;
    print "<form method=post name=updateform action=$gCGI_URL>\n";
    print "<input type=hidden name=db value=$FORM{'db'}>\n"; 
    print "<input type=hidden name=action value=update>\n";
    print "<input type=hidden name=p value=$FORM{'p'}>\n";
    print "<input type=hidden name=l value=$FORM{'l'}>\n";
    print "<input type=hidden name=OldPassword value=$value[0]>\n";
    print "<br><br><table border=0 cellspacing=0 cellpadding=0>\n";
    print "<tr><td>\n";

    print "<table border=0 cellspacing=1 cellpadding=2>\n";    
    print "<tr><td align=right><span class=cls><b>Name</b></span></td><td>\n";
    $value[2] =~ s/<br>/\n/g;
    print "<input name=subject value=\"$value[2]\" type=text size=14 value='' class=text></td></tr>\n";
    print "<tr><td align=right><span class=cls><b>E-Mail</b></span></td><td>\n";
    print "<input type=hidden name=phone value=\"$value[3]\">\n";                             # Ӽ : ó
    print "<input type=hidden name=reply value=\"$value[9]\">\n";                               # Ӽ : ۴ޱ
    print "<input name=email value=\"$value[4]\" type=text size=34 class=text></td></tr>\n";               
    print "<tr><td align=right><span class=cls><b>Homepage</b></span></td><td>\n";
    print "<input name=homepage type=text value=\"$value[8]\" size=34 type=text class=text></td></tr>\n";
    $value[6] =~ s/<br>/\n/g;
    print "<tr><td align=right valign=top><span class=cls><b>Comment</b></span></td><td><textarea name=subject2 rows=8 cols=55 class=comment>$value[6]</textarea></td>\n";    
    print "</tr><tr>\n";
    print "<td align=center colspan=2><input type=submit value=\" Ȯ  \" class=submit onmouseover=\"this.style.backgroundColor= 'silver'\"onmouseout=\"this.style.backgroundColor=''\"> <input type=reset value=\" Է \" class=submit onmouseover=\"this.style.backgroundColor= 'silver'\"onmouseout=\"this.style.backgroundColor=''\"></td>\n";
    print "</tr></table>\n";
    print "</td></tr></table>\n";
    print "</form>\n";
    print "<script language=\"javascript\">document.updateform.subject2.focus();</script>\n";

    &HTMLFooter;       
}

##########################################################################
# ϵ ȭ  ۴ޱ 
##########################################################################
sub showReplyForm {
    local($data,$name,$value);
    local(@cookies);
    
    # Ű б
    local(@value);
    if($ENV{'HTTP_COOKIE'}) {
        @cookies = split(/; /,$ENV{'HTTP_COOKIE'});
        foreach(@cookies) {
            ($name,$value) = split(/=/,$_);
            $COOKIE{$name} = $value;
        }
    }
 
    open(HANDLE,"$gBaseDIR/data/$FORM{'l'}.cgi");
        $data = <HANDLE>;
    close(HANDLE);
    @value = split(/\|/,$data);             

    &HTMLHeader;
    print "<form method=post name=replyform action=$gCGI_URL>\n";
    print "<input type=hidden name=db value=$FORM{'db'}>\n"; 
    print "<input type=hidden name=action value=update>\n";
    print "<input type=hidden name=p value=$FORM{'p'}>\n";
    print "<input type=hidden name=l value=$FORM{'l'}>\n";
    print "<input type=hidden name=OldPassword value=$value[0]>\n";
    print "<br><br><table border=0 cellspacing=0 cellpadding=0>\n";
    print "<tr><td>\n";

    print "<table border=0 width=$gTableWidth cellspacing=2 cellpadding=0 valign=top align=center>\n";
    print "<tr><td align=right></td><td>\n";
    $value[2] =~ s/<br>/\n/g;
    $value[2] =~ s/<p>/\n\n/g;
    print "<input name=subject value=\"$value[2]\" type=hidden size=40>\n";
    print "<input type=hidden name=phone value=\"$value[3]\">\n";
    print "<input name=email value=\"$value[4]\" type=hidden size=40>\n";    
    print "<input name=homepage type=hidden value=\"$value[8]\" size=40 type=text></td></tr>\n";
    print "<input type=hidden name=ip value=\"$value[7]\">\n";                              # Ӽ : ip    
    print "<input type=hidden name=date value=\"$value[5]\">\n";                              # Ӽ : ¥                
    $value[6] =~ s/<br>/\n/g;
    $value[6] =~ s/<p>/\n\n/g;       
    print "<tr><td align=right valign=top><span class=cls><b>Comment</b></span></td><td><table width=405 bgcolor=f5f5f5><tr><td><input type=hidden name=subject2 value=\"$value[6]\"><pre>$value[6]</pre></td></tr></table></td></tr>\n";
    $value[9] =~ s/<br>/\n/g;
    $value[9] =~ s/<p>/\n\n/g;           
    print "<tr><td align=right valign=top><span class=cls><b>Reply</b></span></td><td><textarea name=reply rows=8 cols=55 class=comment>$value[9]</textarea></td></tr>\n";
    print "<tr><td align=center colspan=2><input type=submit value=\" Ȯ  \" class=submit onmouseover=\"this.style.backgroundColor= 'silver'\"onmouseout=\"this.style.backgroundColor=''\"> <input type=reset value=\" Է \" class=submit onmouseover=\"this.style.backgroundColor= 'silver'\"onmouseout=\"this.style.backgroundColor=''\"></td>\n";
    print "</tr></table>\n";
    print "</td></tr></table>\n";
    print "</form>\n";
    print "<script language=\"javascript\">document.replyform.reply.focus();</script>\n";

    &HTMLFooter;       
}

##########################################################################
# йȣ ȣȭѴ
##########################################################################
sub makeCryptPassword  {
    local($crypt_code);
    local(@set);

    @set = ('a'..'z','A'..'Z','0'..'9','.','/');
    $crypt_code = "$set[9]$set[3]";
    $gCryptPassword = crypt($passwd,$crypt_code);
}

##########################################################################
#  ȭ Ѵ
##########################################################################
sub makeNewFile { 
    local(@set);

    @set = ('0'..'9'); 
    srand(time);
    $gRandomFilename = "$d$set[rand(10)]$set[rand(10)]$set[rand(10)]$set[rand(10)]";
    open(HANDLE,">$gBaseDIR/data/$gRandomFilename.cgi");
        print HANDLE "$gCryptPassword|$gRandomFilename|$subject|$phone|$email|$date|$subject2|$ip|$homepage|$reply|$Items||||||\n";
    close(HANDLE);
}

##########################################################################
# ȭϿ  Ѵ
##########################################################################
sub appendIndexFile {
    local($data);
    local(@datum,@point);

    &lock;
    open(HANDLE,"$gBaseDIR/$gDatFile");
        @datum = <HANDLE>;
    close(HANDLE);
    
    if($FORM{'l'}) {    # 亯 ߰ 
        open(HANDLE,">$gBaseDIR/$gDatFile");
        foreach $data (@datum) {
            @point = split(/\|/,$data);
            if($point[1] eq $FORM{'l'}) {
                $thread = $point[0] + 1;
                print HANDLE "$data";
	    print HANDLE "$thread|$gRandomFilename|$subject|$phone|$email|$date|$subject2|$ip|$homepage|$reply|$Items||||||\n";	    
            }
            else {
                print HANDLE "$data";
            }
        }
        close(HANDLE);
     }
     else {
        open(HANDLE,">$gBaseDIR/$gDatFile");
        foreach $data (@datum) {
            if($data =~ /<!--EOF-->/) {
                print HANDLE "<!--EOF-->\n";
	        print HANDLE "0|$gRandomFilename|$subject|$phone|$email|$date|$subject2|$ip|$homepage|$reply|$Items||||||\n";	    
            }
            else {
                print HANDLE "$data";
            }
        }
        close(HANDLE);
    }
    &unlock;
}

##########################################################################
# Ʈ  ϵ ȭ ã Ѵ
##########################################################################
sub updateData {
    local(@datum,@value);

    &getVariable;
   
    open(HANDLE,"<$gBaseDIR/$gDatFile");
        @datum = <HANDLE>;
    close(HANDLE);

    open(HANDLE,">$gBaseDIR/$gDatFile");
    foreach $data (@datum) {
        @value = split(/\|/,$data);
        if($FORM{'l'} eq $value[1]) {
#                                      0       |ȣ            |(̸)|ó|̸|¥        |  |ip|Ȩ       |       ||||||
            print HANDLE "$value[0]|$FORM{'l'}|$subject|$phone|$email|$date|$subject2|$ip|$homepage|$reply|$Items||||||\n";
        }
        else {
            print HANDLE "$data";
        }
    }
    close(HANDLE);
    open(HANDLE,">$gBaseDIR/data/$FORM{'l'}.cgi");
#                                               ȣ            |ȭϸ        |(̸)|ó|̸|¥  |       |ip|Ȩ      |      |||||||
        print HANDLE "$FORM{'OldPassword'}|$FORM{'l'}|$subject|$phone|$email|$date|$subject2|$ip|$homepage|$reply|$Items||||||\n";
    close(HANDLE);

    print "Content-type: text/html\n\n";
    print "<!---------------------------------------------------------------------------------->\n";
    print "<!--  Program Name  : Beomdori's GuestBook $gVer                                   -->\n";
    print "<!--  Programer     : BeomGyu Lee                                                  -->\n";
    print "<!--  E-Mail        : cadeau\@orgio.net                                           -->\n";
    print "<!--  Homepage      : http://beomdori.x-y.net                                     -->\n";
    print "<!---------------------------------------------------------------------------------->\n\n";
    print "<html>\n";
    print "<title>Beomdori's GuestBook $gVer</title>\n";    
    print "<meta http-equiv=\"desription\" name=\"description\" content=\"text/html; charset=KS_C_5601-1987; charset=euc-kr\">\n";        
    print "<link rel=\"stylesheet\" type=\"text/css\" href=\"./bdr_guest.css\">\n";
    print "<style>\n" ;
    print " BODY {background:url(\"$gBackImgURL\") $gBackColor fixed no-repeat 98% 98%}\n";
    print "</style>\n" ;    
    print "<script language=\"JavaScript\">\n";
    print "function nextWin()\n";
    print "{location = \"$gCGI_URL?db=$FORM{'db'}&action=r&p=$FORM{'p'}\"}\n";
    print "</script>\n";

    if($gDelayTime == 0) {
       $gBackColor = "#ffffff" unless($gBackColor);
       print "<body bgcolor=$gBackColor oncontextmenu='return false'>\n";
    }
    else {
        print "<meta http-equiv=refresh content=2;url=$gCGI_URL?db=$FORM{'db'}&action=r&p=$FORM{'p'}>\n";
        $gBackColor = "#ffffff" unless($gBackColor);
        print "<body bgcolor=$gBackColor oncontextmenu='return false'>\n";
    }

    print "<meta http-equiv=refresh content=\"0;  url=$gCGI_URL?db=$FORM{'db'}&action=r&p=$FORM{'p'}\">\n";

    print "</body></html>\n";
}

##########################################################################
#  α
##########################################################################
sub showAdminLogin {
    local($command);
    	
    &HTMLHeader;
    unless(open(HANDLE,"$gBaseDIR/$gPwdFile")) {
        print "<br><br><form action=$gCGI_URL name=passwdconfig>\n";
        print "<input type=hidden name=db value=$FORM{'db'}>\n";    
        print "<input type=hidden name=action value=$FORM{'c'}>\n";
        print "<input type=hidden name=p value=$FORM{'p'}>\n";
        print "<input type=hidden name=ps value=new>\n";
        print "<b> йȣ </b><br><br>\n";
        print "<table border=0 width=150>\n";
        print "<tr><td width=50 align=left>йȣ</td><td align=left><input type=password name=newpasswd size=12 maxlength=16></td></tr>\n";
        print "<tr><td width=50 align=left>  </td><td align=left><input type=password name=repasswd size=12 maxlength=16></td></tr>\n";
        print "<tr><td width=50></td><td align=left><input type=submit value=\" Ȯ \"></td></tr>\n";
        print "</table>\n";
        print "</font></form>\n";
        print "<script language=\"javascript\">document.passwdconfig.newpasswd.focus();</script>\n";                        
    }
    else {
        print "<br><form method=post name=config action=$gCGI_URL>\n";
        print "<input type=hidden name=db value=$FORM{'db'}>\n"; 
        print "<input type=hidden name=action value=$FORM{'c'}>\n";
        print "<input type=hidden name=p value=$FORM{'p'}>\n";
        print "<input type=hidden name=ps value=old>\n";
        print "<b>Config</b><br>\n";      
        print "<input type=hidden name=action value=$FORM{'c'} checked style=\"background-color:#ffffff;border:1 solid white\">\n";
        print "<br>йȣ&nbsp;<input type=password name=oldpasswd size=12 maxlength=16>\n";
        print " <input type=submit value=\" Ȯ \">\n";
        print "</form>\n";
        print "<script language=\"javascript\">document.config.oldpasswd.focus();</script>\n";
    }
    &HTMLFooter;
    close(HANDLE);
}

##########################################################################
#  ȣüũ
########################################################################## 
sub checkAdminPassword {
    local($crypt_code,$save_password,$old_password,$new_password);
    local(@set);

    
    # йȣ űԷ
    if($FORM{'ps'} eq "new") {  
        if($FORM{'newpasswd'} eq $FORM{'repasswd'}) {
            if($FORM{'newpasswd'} ne "") {
                @set = ('a'..'z','A'..'Z','0'..'9','.','/');
                $crypt_code = "$set[9]$set[3]";
                $save_password = crypt($FORM{'newpasswd'},$crypt_code);
                open(HANDLE,">$gBaseDIR/$gPwdFile");
                    print HANDLE "$save_password\n";
	                close(HANDLE);
            }
            else {
                &HTMLHeader;
                print "<br><br><hr noshade width=80%>\n";
                print "<font color=blue> йȣ Է ʾҽϴ</font>\n";
                print "<hr noshade width=80%>\n";
                print "</form><p><a href=$gCGI_URL?db=$FORM{'db'}&action=r&p=$FORM{'p'}><font color=$gTextColor>[ư]</font></a>\n";

                &HTMLFooter;
            }
        }
        else {
            &HTMLHeader;
            print "<br><br><hr noshade width=80%>\n";
            print "<font color=blue> йȣ ġ ʽϴ</font>\n";
            print "<hr noshade width=80%>\n";
            print "</form><p><a href=$gCGI_URL?db=$FORM{'db'}&action=r&p=$FORM{'p'}><font color=$gTextColor>[ư]</font></a>\n";
            &HTMLFooter;
        } 
    } 

    # йȣ Ȯ
    else { 
        open(HANDLE,"<$gBaseDIR/$gPwdFile");
            $save_password = <HANDLE>;
        close(HANDLE);
        chop($save_password);

        @set = ('a'..'z','A'..'Z','0'..'9','.','/');
        $crypt_code = "$set[9]$set[3]";
        $old_password = crypt($FORM{'oldpasswd'},$crypt_code);

        unless($old_password eq $save_password) {
            &HTMLHeader;
            print "<br><br><hr noshade width=80%>\n";
            print "<font color=blue> йȣ ġ ʽϴ</font>\n";
            print "<hr noshade width=80%>\n";
            print "</form><p><a href=$gCGI_URL?db=$FORM{'db'}&action=r&p=$FORM{'p'}><font color=$gTextColor>[ư]</font></a>\n";
            &HTMLFooter;
        }
    }
}

##########################################################################
# ȣ üũ
##########################################################################
sub checkConfigPassword {
    local($crypt_code,$save_password,$old_password,$new_password,$cur_passwd);
    local(@set);
 
        open(HANDLE,"<$gBaseDIR/$gPwdFile");
            $save_password = <HANDLE>;
        close(HANDLE);
        chop($save_password);

        @set = ('a'..'z','A'..'Z','0'..'9','.','/');
        $crypt_code = "$set[9]$set[3]";
        $old_password = crypt($FORM{'oldpasswd'},$crypt_code);

        unless($old_password eq $save_password) {
            &HTMLHeader;
	        print "<br>| <a href=\"javascript:history.back()\">ڷ</a> |\n";
            print "<br><br><hr noshade width=80%>\n";
            print "<font color=blue>ȯ漳 Ȯ   йȣ ġ ʽϴ.</font>\n";
            print "<hr noshade width=80%>\n";
            &HTMLFooter;
        }
}


##########################################################################
# ڿ  ȯ漳
##########################################################################
sub showConfigForm {
    &HTMLHeader;
    print "<br><b><font color=\"3355cc\">Beomdori's GuestBook $gVer</font></b><br><br>\n";
    print "<table border=0 width=500><tr><td>\n";
    print "<form action=$gCGI_URL>\n";
    print "<input type=hidden name=db value=$FORM{'db'}>\n";
    print "<input type=hidden name=action value=config>\n";
    print "<input type=hidden name=p value=$FORM{'p'}>\n";
    print "<input type=hidden name=ps value=new>\n";

# DB 
    print "<table border=0 width=100% cellpadding=2 cellspacing=1 onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">\n";
    print "<tr align=left><td colspan=2><b> :: DB :: </b></td></tr>\n";
    if($gCreateDB eq "Y") {
        $gCreateDB = "";
    } 
    else {
        $gCreateDB = "";
    }    
    print "<tr><td align=left>DB ߰ </td><td align=right><font color=red><b>$gCreateDB</b></font>\n";
    print "</td></tr>\n";
    print "<tr><td align=left>Design Style</td>\n";
    print "<td align=right><select name=DesignType>\n";
    if($gDesignType eq "style1") {
        print "<option value=style1 selected>Ÿ1&nbsp;&nbsp;&nbsp;";
        print "<option value=style2>Ÿ2&nbsp;&nbsp;&nbsp;";
        print "<option value=style3>Ÿ3&nbsp;&nbsp;&nbsp;";
    }
    elsif($gDesignType eq "style2") {
        print "<option value=style1>Ÿ1&nbsp;&nbsp;&nbsp;";
        print "<option value=style2 selected>Ÿ2&nbsp;&nbsp;&nbsp;";
        print "<option value=style3>Ÿ3&nbsp;&nbsp;&nbsp;";
    }
    elsif($gDesignType eq "style3") {
        print "<option value=style1>Ÿ1&nbsp;&nbsp;&nbsp;";
        print "<option value=style2>Ÿ2&nbsp;&nbsp;&nbsp;";
        print "<option value=style3 selected>Ÿ3&nbsp;&nbsp;&nbsp;";
    }    
    print "</select></td></tr>\n";
    print "</table><br>\n";

# йȣ     
    print "<table border=0 width=100% cellpadding=2 cellspacing=1 onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">\n";
    print "<tr align=left><td colspan=2><b> :: йȣ  :: </b></td></tr>\n";
    print "<tr align=right><td align=left>йȣ</td><td align=right><input type=password name=newpasswd size=12 maxlength=16></td></tr>\n";
    print "<tr align=right><td align=left>Է</td><td align=right><input type=password name=repasswd size=12 maxlength=16>\n";
    print "</td></tr></table><br>\n";

######
    print "<table border=0 width=100% cellpadding=2 cellspacing=1 onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">\n";
    print "<tr align=left><td colspan=2><b> ::  :: </b></td></tr>\n";
    
    print "<tr><td align=left>Title ̱</td>\n";
    print "<td align=right><select name=TitleUse>\n";
    if($gTitleUse eq "YES" || $gTitleUse eq "") {
        print "<option value=YES selected>";
        print "<option value=NO>Ұ&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
    }
    elsif($gTitleUse eq "NO") {
        print "<option value=YES>";
        print "<option value=NO selected>Ұ&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
    }
    print "</select></td></tr>\n";    
    
    print "<tr><td align=left>Background Color</td><td align=right><table border=1  bgcolor=black bordercolor=\"#cccccc\"  bordercolorlight=\"black\" bordercolordark=\"white\" cellspacing=0 cellpadding=0 align=right valign=top><tr><td bgcolor=\"$gBackColor\">&nbsp;&nbsp;</td></tr></table><input type=text name=BackColor value=\"$gBackColor\" size=10></td></tr>\n";
    print "<tr><td align=left>Text Color</td><td align=right><table border=1 bgcolor=black bordercolor=\"#cccccc\"  bordercolorlight=\"black\" bordercolordark=\"white\" cellspacing=0 cellpadding=0 align=right valign=top><tr><td bgcolor=\"$gTextColor\">&nbsp;&nbsp;</td></tr></table><input type=text name=TextColor value=\"$gTextColor\" size=10></td></tr>\n";
    print "<tr><td align=left>Background URL</td><td align=right><input type=text name=BackImgURL value=\"$gBackImgURL\" size=40></td></tr>\n";
    print "</table><br>\n";

### ###
    print "<table border=0 width=100% cellpadding=2 cellspacing=1 onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">\n";
    print "<tr align=left><td colspan=2><b> ::   :: </b></td></tr>\n";

    print "<tr><td align=left>̺ Bgcolor</td><td align=right><table border=1 bgcolor=black bordercolor=\"#cccccc\"  bordercolorlight=\"black\" bordercolordark=\"white\" cellspacing=0 cellpadding=0 align=right valign=top><tr><td bgcolor=\"$gTableBgcolor\">&nbsp;&nbsp;</td></tr></table><input type=text name=TableBgcolor value=\"$gTableBgcolor\" size=10></td></tr>\n";
    print "<tr><td align=left>̺ Text</td><td align=right><table border=1 bgcolor=black bordercolor=\"#cccccc\"  bordercolorlight=\"black\" bordercolordark=\"white\" bgcolor=black cellspacing=0 cellpadding=0 align=right valign=top><tr><td bgcolor=\"$gTableText\">&nbsp;&nbsp;</td></tr></table><input type=text name=TableText value=\"$gTableText\" size=10></td></tr>\n";    
    print "<tr><td align=left>Ȱȭ ̺ Color</td><td align=right><table border=1 bgcolor=black bordercolor=\"#cccccc\"  bordercolorlight=\"black\" bordercolordark=\"white\" cellspacing=0 cellpadding=0 align=right valign=top><tr><td bgcolor=\"$gActiveTableColor\">&nbsp;&nbsp;</td></tr></table><input type=text name=ActiveTableColor value=\"$gActiveTableColor\" size=10></td></tr>\n";
    print "</table><br>\n";

###Display ###
    print "<table border=0 width=100% cellpadding=2 cellspacing=1 onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">\n";
    print "<tr align=left><td colspan=2><b> :: Display  :: </b></td></tr>\n";
    print "<tr><td align=left>Table Size</td><td align=right><input type=text name=TableWidth value=\"$gTableWidth\" size=12 maxlength=4></td></tr>\n";
    print "<tr><td align=left>ǥ </td><td align=right><input type=text name=RecPerPage value=\"$gRecPerPage\" size=12 maxlength=2></td></tr>\n";
    print "<tr><td align=left>Ʈ  </td><td align=right><input type=text name=ListNumber value=\"$gListNumber\" size=12 maxlength=2></td></tr>\n";
    print "</table><br>\n";

    print "<p align=center>\n";
    print "<input type=submit value=\" Ȯ  \">\n";
    print "</form>\n";
    print "</tr></td></table>\n";

    &HTMLFooter;
}

##########################################################################
# ȯ漳 ƮѴ
##########################################################################
sub updateEnvVar {
    &checkAdminPassword if($FORM{'newpasswd'} || $FORM{'repassword'});

    $gDesignType = $FORM{'DesignType'};
    $gBackColor = $FORM{'BackColor'};
    $gTextColor = $FORM{'TextColor'};
    $gBackImgURL = $FORM{'BackImgURL'};
    $gTempURL3 = $FORM{'TitleText'};
    $gTempURL2 = $FORM{'TempURL2'} if($FORM{'TempURL2'} =~ /^http:\/\// || $FORM{'TempURL2'} eq "");
    $gTempColor1 = $FORM{'TempColor1'};
    $gTempColor2 = $FORM{'TempColor2'};
    $gTempColor7 = $FORM{'TempColor7'};

    $gTableText = $FORM{'TableText'};

    $gTableWidth = $FORM{'TableWidth'};         
    $gRecPerPage = $FORM{'RecPerPage'} if($FORM{'RecPerPage'} >= 1);

    $gListNumber = $FORM{'ListNumber'};
    $gTempColor4 = $FORM{'TempColor4'};

    $gTempColor9 = $FORM{'TitleColor'};

    $gActiveTableColor = $FORM{'ActiveTableColor'};

    $gTempYesOrNo1 = $FORM{'TagUse'};

    $gTitleUse = $FORM{'TitleUse'};
    $gTempColor3 = $FORM{'TempColor3'};
    $gTempNum1 = $FORM{'TopMargin'};

    $gTableBgcolor = $FORM{'TableBgcolor'};
    $gTempcolor1 = $FORM{'TempColor1'};
    $gTempcolor2 = $FORM{'TempColor2'};

    $gTempYesOrNo2 = $FORM{'TempYesOrNo2'};
    $gTempYesOrNo3 = $FORM{'TempYesOrNo3'};

    $gTempURL1 = $FORM{'TableImage'};

    $gTempColor8 = $FORM{'TitleBack'};

    $gTempURL9 = $FORM{'Item'};
    $gTempURL4 = $FORM{'Item1'};
    $gTempURL5 = $FORM{'Item2'};
    $gTempURL6 = $FORM{'Item3'};
    $gTempURL7 = $FORM{'Item4'};
    $gTempURL8 = $FORM{'Item5'};

    $gTempYesOrNo6 = $FORM{'TempYesOrNo6'};

    $gTempYesOrNo4 = $FORM{'TempYesOrNo4'};
    $gTempYesOrNo5 = $FORM{'TempYesOrNo5'};
    
    &putEnvVar;
    $gCurPage = $FORM{'p'};
    &readData;
}

sub lock {
    local($LockFile) = "$gBaseDIR/lock.txt";
    local($EndTime) = time+45;

    while(-e $LockFile && time < $EndTime) {}
    open(LOCK,">$LockFile");
    chmod 0666,$LockFile;

    if($gLockFlag eq 'Y') {
        flock(LOCK,2);
    }
    $gLockStat = 'Y';
}    

sub unlock {
    local($LockFile) = "$gBaseDIR/lock.txt";

    if($gLockStat eq 'Y') {
        if($gLockFlag eq 'Y') {
            flock(LOCK,8); 
        }
        close(LOCK);
        if(-e $LockFile) { 
            unlink($LockFile);
        }
        $gLockStat = 'N'; 
    }
}

#ũ
#value0 = 0
#value1 = ȭ
#value2 = ̸/
#value3 = ó
#value4 = ̸
#value5 = ð
#value6 = 
#value7 = IP
#value8 = Ȩ
#value9 = 
#value10 = 
#value11 = 
#value12 = 
#value13 = 
#value14 = 
#value15 = 